unit Unit1;

{$mode objfpc}{$H+}

{if you want a clean surface without example data and example controls enable
 the switch 'UseExampleCode' by removing the statement or comment it
 and everything what you dont need will be engrayed
 You also may therefore delete all Code enclosed in this define brackets
 including the define statements witout any damage

     {$ifdef UseExampleCode}
      ...any Code
    {$endif}

 }

{.$DEFINE UseExampleCode}

interface

uses
  Classes, SysUtils, DB, SQLDB, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, ExtCtrls, DBCtrls, ComCtrls, Buttons
  ,udmsqldb
  ,fcredentials
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    bttnManageCredentials: TBitBtn;
    comboConnectorType: TComboBox;
    DataSource1: TDataSource;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    Panel1: TPanel;
    Panel2: TPanel;
    SQLQuery1: TSQLQuery;
    StatusBar1: TStatusBar;

    {$ifdef UseExampleCode}
      {$include demo1.inc}
    {$endif}
    procedure comboConnectorTypeChange(Sender: TObject);
    procedure bttnManageCredentialsClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private

  public

  end;

var
  Form1: TForm1;
  {$ifdef UseExampleCode}
  MemoLog:TMemo;
  {$endif}
  procedure CeckDataModuleAssigned;


implementation

procedure CeckDataModuleAssigned;
begin
  //Check if the datamodule exists before using it
  if not assigned(dmsqldb) then
    raise Exception.Create( LineEnding
                          + 'File: ' + {$INCLUDE %FILE%} + LineEnding
                          + 'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding
                          + 'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding +LineEnding
                          + 'The data module has not yet been created. Please note that the data module must be created '
                          + 'before the main form. Check the order of creation in the project options (Ctrl+Shift+F11) '
                          + 'under position forms '
                          + LineEnding
                          );
end;

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  {$ifdef UseExampleCode}
  CreateControls;
  {$endif}
  CeckDataModuleAssigned;    //check if the datamodule already exists
  with comboConnectorType do //fill the combo box
  begin
    Items.AddDelimitedtext(GetDBconnectionsFromIni,';',true);
    text:=dmsqldb.prCredentials.section;
  end;

end;

procedure TForm1.FormActivate(Sender: TObject);
var
  OldCursor: TCursor;
begin
  OldCursor:=Screen.Cursor;
  StatusBar1.SimpleText:='Please wait, database is created and prepared....';

  {$ifdef UseExampleCode}ToggleControls;{$endif}
  Screen.Cursor := crSQLWait;
  Application.ProcessMessages;
  try
    {$ifdef UseExampleCode}
    MyOpenQuery;
    ToggleControls;
    {$endif}
    If dmsqldb.SQLConnector1.Connected then
      StatusBar1.SimpleText:='Database ready'
    else
      StatusBar1.SimpleText:='Database offline';
  finally
    Screen.Cursor:=OldCursor;
    Application.ProcessMessages;
  end;

  //Maybe your code goes here...
  SQLQuery1.SQL.Text:='SELECT FirstName,LastName,Company,Address,City,State,Country,PostalCode,Phone from customer';
  SQLQuery1.Open;
end;

procedure TForm1.comboConnectorTypeChange(Sender: TObject);
begin
  ////
end;

procedure TForm1.bttnManageCredentialsClick(Sender: TObject);
var
  myForm:TfrmCredentials;
begin
  myForm:=TfrmCredentials.Create(self);
  myForm.ShowModal;
  myForm.Free;
end;

{$ifdef UseExampleCode}
  {$include demo2.inc}
{$endif}

end.

