procedure TForm1.bttnQueryClick(Sender: TObject);
begin
  MyOpenQuery;
end;

procedure TForm1.bttnConnectClick(Sender: TObject);
begin

        MemoLog.Clear;
        MemoLog.Append('Connecting...');
        memoLog.Append(dmsqldb.ListConnectionTypes);

        if not assigned(dmsqldb) then exit;
        MemoLog.Append(LineEnding+'using Library:' + LineEnding + dmsqldb.SQLDBLibraryLoader1.LibraryName+LineEnding);

        dmsqldb.OpenConnection;

        if dmsqldb.SQLConnector1.Connected then memolog.Append(LineEnding+'Database: '+dmsqldb.SQLConnector1.DatabaseName) ;
        memolog.Append(LineEnding+'SQLite Version: '+dmsqldb.GetSQLiteVersion);
        memolog.Append(LineEnding+'Connected');

   bttnConnect.Enabled:=false;
   bttnDisconnect.Enabled:=true;
   bttnQuery.Enabled:=true;
   bttnImport.Enabled:=true;


end;

procedure TForm1.bttnDisconnectClick(Sender: TObject);
begin

        if not assigned(dmsqldb) then exit;
        dmsqldb.SQLConnector1.Connected:=false;
        if not dmsqldb.SQLConnector1.Connected then memolog.Append('Disconnected ') ;
        freeandnil(dmsqldb);

   bttnConnect.Enabled:=true;
   bttnDisconnect.Enabled:=false;
   bttnQuery.Enabled:=false;
   bttnImport.Enabled:=false;

end;

procedure TForm1.bttnImportClick(Sender: TObject);
begin
   MemoLog.Append('Importing data, please wait...');
   dmsqldb.ImportData;
   MemoLog.Append(LineEnding+'dmsqldb: Import was done');
end;

procedure TForm1.Button1Click(Sender: TObject);
begin

end;


procedure TForm1.MyOpenQuery;
var
  s:string;
begin
  if SQLQuery1.Active then SQLQuery1.Close;
  SQLQuery1.DataBase:=dmsqldb.SQLConnector1;  // either assign the database connection by code or Lazarus-GUI

  s:=MemoSQL.Lines.Text;
  SQLQuery1.SQL.Text := s;
  SQLQuery1.Open;
end;



procedure TForm1.ToggleControls(iWhatToDo: integer);
begin
  case iWhatToDo of
    0: begin
      //just toggle Controls
      bttnConnect.Visible:=not bttnConnect.Visible;
      bttnDisconnect.Visible:= not bttnDisconnect.Visible;
      bttnQuery.Visible:= not bttnQuery.Visible;
      bttnImport.Visible:=not bttnImport.Visible;
      DBGrid1.Visible:= not DBGrid1.Visible;
      DBNavigator1.Visible:= not DBNavigator1.Visible;
      MemoLog.Visible:= not MemoLog.Visible;
      MemoSQL.Visible:= not MemoSQL.Visible;
      pnlLeft.Visible:= not pnlLeft.Visible;
      Splitter1.Visible:= not Splitter1.Visible;
    end;
    1: begin
      //Prepare for manual action
    end;
  end;



end;

procedure TForm1.CreateControls;
begin

  pnlLeft:= TPanel.Create(self);
  with pnlLeft do
  begin
    parent := self;
    name := 'pnlLeft';
    Left := 0;
    Height := 573;
    caption:='';
    Top := 0;
    Width := 649;
    Align := alLeft;
    ClientHeight := 573;
    ClientWidth := 649;
    TabOrder := 0;
  end;

  Splitter1:= TSplitter.Create(self);
  with Splitter1 do
  begin
    parent := self;
    name := 'Splitter1';
    Left := 649;
    Height := 573;
    Top := 0;
    Width := 9;
  end;

  Panel1:=TPanel.Create(self);
  with Panel1 do
  begin
    parent := pnlLeft;
    name := 'Panel1';
    caption:='';
    Left := 1;
    Height := 38;
    Top := 534;
    Width := 647;
    Align := alBottom;
    BevelOuter := bvNone;
    ClientHeight := 38;
    ClientWidth := 647;
    TabOrder := 0;
  end;

  DBNavigator1:= TDBNavigator.Create(self);
  with DBNavigator1 do
  begin
    parent := Panel1;
    name := 'DBNavigator1';
    Left := 225;
    Height := 38;
    Top := 0;
    Width := 422;
    Align := alRight;
    BevelOuter := bvNone;
    ChildSizing.EnlargeHorizontal := crsScaleChilds;
    ChildSizing.EnlargeVertical := crsScaleChilds;
    ChildSizing.ShrinkHorizontal := crsScaleChilds;
    ChildSizing.ShrinkVertical := crsScaleChilds;
    ChildSizing.Layout := cclLeftToRightThenTopToBottom;
    ChildSizing.ControlsPerLine := 100;
    ClientHeight := 38;
    ClientWidth := 422;
    DataSource := DataSource1;
    Options := [];
    TabOrder := 0;
  end;

  Panel2:=TPanel.Create(self);
  with Panel2 do
  begin
    parent := pnlLeft;
    name := 'Panel2';
    caption:='';
    Left := 1;
    Height := 272;
    Top := 1;
    Width := 647;
    Align := alTop;
    BevelOuter := bvNone;
    ClientHeight := 272;
    ClientWidth := 647;
    TabOrder := 0;
  end;

  DBGrid1:= TDBGrid.Create(self);
  with DBGrid1 do
  begin
    parent := pnlLeft;
    name := 'DBGrid1';
    Left := 1;
    Height := 261;
    Top := 273;
    Width := 647;
    Align := alClient;
    Color := clWindow;
   // Columns := <>;
    DataSource := DataSource1;
    Options := [dgEditing, dgTitles, dgIndicator, dgColumnResize, dgColumnMove, dgColLines, dgRowLines, dgTabs, dgAlwaysShowSelection, dgConfirmDelete, dgCancelOnExit, dgAutoSizeColumns];
    TabOrder := 2;
  end;

  bttnConnect:=TButton.Create(self);
  with bttnConnect do
  begin
    parent := panel2;
    name := 'bttnConnect';
    Left := 32;
    Height := 44;
    Top := 56;
    Width := 224;
    Caption := '1: Connect to DB';
    OnClick := @bttnConnectClick;
    TabOrder := 0;
  end;

  bttnImport:=TButton.Create(self);
  with bttnImport do
  begin
    parent := panel2;
    name := 'bttnImport';
    Left := 32;
    Height := 44;
    Top := 105;
    Width := 224;
    Caption := '2: Import Data';
    Enabled := False;
    OnClick := @bttnImportClick;
    TabOrder := 1;
  end;
  bttnQuery:=TButton.Create(self);
  with bttnQuery do
  begin
    parent := panel2;
    name := 'bttnQuery';
    Left := 32;
    Height := 44;
    Top := 154;
    Width := 224;
    Caption := '3: Query Table';
    Enabled := False;
    OnClick := @bttnQueryClick;
    TabOrder := 2;
  end;
  MemoSQL:=TMemo.Create(self);
  with MemoSQL do
  begin
    parent := panel2;
    name := 'MemoSQL';
    Left := 264;
    Height := 46;
    Top := 154;
    Width := 372;
    Lines.Clear;
    Lines.Append('select * from customer');
    TabOrder := 3;
  end;
  bttnDisconnect:=TButton.Create(self);
  with bttnDisconnect do
  begin
    parent := panel2;
    name := 'bttnDisconnect';
    Left := 33;
    Height := 44;
    Top := 224;
    Width := 224;
    Caption := 'Disconnect from DB';
    Enabled := False;
    OnClick := @bttnDisconnectClick;
    TabOrder := 4;
  end;

  MemoLog:=TMemo.Create(self);
  with MemoLog do
  begin
    parent := self;
    name := 'MemoLog';
    Left := 658;
    Height := 573;
    Top := 0;
    Width := 532;
    Align := alClient;
    Lines.Clear;
    Lines.Append('A database was automatically created, the access library was searched and demo data was imported');
    Lines.Append('');
    Lines.Append('The database is ready and running.');
    Lines.Append('');
    Lines.Append('If you want you can test the connection manually using the buttons');
    ScrollBars := ssBoth;
    TabOrder := 2;
  end;

  //with TComboBox.Create(self) do
  //begin
  //  Parent:=StatusBar1;
  //  name:='cbConnectorType';
  //  align := alRight;
  //  Height := 21;
  //  Width := 140;
  //  ItemHeight := 30;
  //  OnChange := @cbConnectorTypeChange;
  //  ReadOnly := True;
  //  TabOrder := 0;
  //  Items.AddDelimitedtext(dmsqldb.psPossibleConnectorTypes,';',true);
  //  Text:=dmsqldb.psConnectorType;
  //
  //  //AnchorSideLeft.Side := asrCenter;
  //  //AnchorSideTop.Control := StatusBar1;
  //  //AnchorSideTop.Side := asrCenter;
  //  AnchorSideRight.Control := StatusBar1;
  //  AnchorSideRight.Side := asrBottom;
  //  Anchors := [akTop, akRight];
  //  BorderSpacing.Right := 23;
  //
  //  //Left = 512
  //  //Height = 23
  //  //Top = 317
  //
  //end;

end;                    
