unit udmsqldb;

{$mode ObjFPC}{$H+}

//Switches:
//You can disable switches by using a period after the curved
//bracket like this  {.$DEFINE SWITCHNAME}

{If you want to use a SQL log  enable the switch}
{.$DEFINE UseSQLLOG}

{Note: an extra possibility to run queries that have no result like  INSERT, DELET or DDL language
 - SQLQuery1 is provided.
Create your own SQLQuery-Components as well as own Datasource-Components in your forms and
connect them with the SQLConnector1
}


interface

uses
  Classes, SysUtils, SQLDBLib, SQLDB, Forms
  {$ifdef UseSQLLOG}
  , LazLogger
  {$endif}

  , SQLite3Conn
  //,pqconnection     //PostgreSQ
  //,ibconnection     //Interbase ,Firebird
  //,mssqlconn        //MSSQL Server , Sybase
  //,oracleconnection //Oracle
  //,odbcconn         //ODBC Access
  //,mysql40conn      //different MySQL Versions as well as MariaDB
  //,mysql41conn
  //,mysql50conn
  //,mysql51conn
  //,mysql55conn
  //,mysql56conn
  //,mysql57conn
  //,mysql80conn

  ;

const
  //{$include demosettings.Inc}
  cSQLiteType='SQLite3';
  cConnectorType='SQLite3';


type
  TDBCredentials = record
    Server: string;
    Port: integer;
    DatabaseName : string;
    Username: string;
    Password: string;
    ConnectorType: string;
    //LibraryName: string;
    CustomLibraryName:string;
    ValidConnection:string; //had a valid connection before
    caption:string;
    section:string;
end;


//TSQLServerType  copied from SQLDBToolsunit.pas therefore they may be unsynchronized
//type
//  TSQLServerType = (ssFirebird, ssInterbase, ssMSSQL, ssMySQL, ssOracle, ssPostgreSQL, ssSQLite, ssSybase, ssUnknown);
//
type

  { Tdmsqldb }

  Tdmsqldb = class(TDataModule)
    SQLConnector1: TSQLConnector;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLQuery1: TSQLQuery;
    SQLScript1: TSQLScript;
    SQLTransaction1: TSQLTransaction;
    {$ifdef UseSQLLOG}
    procedure DoSQLLog(Sender: TSQLConnection; EventType: TDBEventType; const Msg: String);
    {$endif}
    procedure DataModuleCreate(Sender: TObject);
  private
    FbAllowOpenDialogOnSQLImportFile: boolean;
    FDeleteDatabasefileBeforeOpen: boolean;
    FImportDemoDataOnCreate: boolean;
    FsConnectorType: string;
    FsIniFileName: String;
    FsPossibleConnectorTypes: string;
    FrCredentials:TDBCredentials;  //Credentials-Record
    FsPossibleDatabaseConnections: string;  //String of possible Database Connectiond from INIfile
    FsSQLCustomImportFileName: string;
//    SQLServerType : TSQLServerType;
    procedure SetbAllowOpenDialogOnSQLImportFile(AValue: boolean);
    procedure SetbDeleteDatabasefileBeforeOpen(AValue: boolean);
    procedure SetbImportDemoDataOnCreate(AValue: boolean);
    procedure SetConnectorType(AValue: string);
    procedure SetsIniFileName(AValue: String);
  public
    procedure Initialize;
    procedure ImportData(sImportFile: string='');
    procedure OpenConnection;
    procedure CloseConnection;

    {lists the available connection types depending on the SQL units included in the uses section;
    if bCreateText is false you will get the the possible connector Types in case you will choose them and switch between;
    possible Connector Types are stored in the property psPossibleConnectorTypes}
     function ListConnectionTypes(bCreateText:boolean=true):string;

    {determines the standard library for a given connection type depending on the SQL units included in the uses section }
    function GetStandardLibraryName(sConnector:string):string;

    {determines and loads the SQL access library depending on the different operating systems and the selected connection type}
    procedure MyLoadLib(sConnectionType,sLibname : String);
    function MyGetLibraryName:string;
    procedure SetCredentialsToSQLConnector;

    {returns the current SQLite Version if SQLite is chosen as ConnectorType}
    function GetSQLiteVersion:string;

    {In case you need an additional TSQLQuery}
    function GetQuery : TSQLQuery;

    procedure ReadStandardSectionFromIni;
    function ReadDefaultCredentialsFromIni: TDBCredentials;
    procedure RefreshCredentials(sSection: string);
    function GetCredentialsFromIniSection(sSection: string; sIniFileName: string ): TDBCredentials;


    property psPossibleConnectorTypes:string read FsPossibleConnectorTypes;
    property psPossibleDatabaseConnections:string read FsPossibleDatabaseConnections;
    property psConnectorType:string read FsConnectorType write SetConnectorType;

    property pbDeleteDatabasefileBeforeOpen:boolean read FDeleteDatabasefileBeforeOpen write SetbDeleteDatabasefileBeforeOpen;
    property pbImportDemoDataOnCreate:boolean read FImportDemoDataOnCreate write SetbImportDemoDataOnCreate;
    property psIniFileName:String read FsIniFileName write SetsIniFileName;
    property pbAllowOpenDialogOnSQLImportFile:boolean read FbAllowOpenDialogOnSQLImportFile write SetbAllowOpenDialogOnSQLImportFile;
    property prCredentials:TDBCredentials read FrCredentials;
  end;

var
  dmsqldb: Tdmsqldb;
  //function GetCredentialsFromIniSection(sSection:string; sIniFileName:string=''):TDBCredentials;
  function GetDefaultCredentials(FsConnectorType:string):TDBCredentials;
  function GetDBconnectionsFromIni:string;
implementation

uses
  dialogs ,inifiles ,uguessfile,fcredentials;

//function GetCredentialsFromIniSection(sSection: string; sIniFileName: string
//  ): TDBCredentials;
//var
//   MyIni:TIniFile;
//   rStdCredentials:TDBCredentials;
//   sMyIniFileName:string;
//   sMyConnectorType:string;
//begin
//
//   if sIniFileName = '' then
//     sMyIniFileName:=GuessDBIniFile
//   else
//     sMyIniFileName:=sIniFileName;
//
//   MyIni := TIniFile.Create(sMyIniFileName);
//   try
//     sMyConnectorType:=MyIni.ReadString(sSection,'ConnectorType',cConnectorType);
//     rStdCredentials:=GetDefaultCredentials(sMyConnectorType);
//
//     result.Server:=MyIni.ReadString(sSection,'Server',rStdCredentials.server);
//     result.username:=MyIni.ReadString(sSection,'Username',rStdCredentials.username);
//     result.password:=MyIni.ReadString(sSection,'Password',rStdCredentials.password);
//     result.DatabaseName:=MyIni.ReadString(sSection,'DatabaseName',rStdCredentials.DatabaseName);
//     result.ConnectorType:=MyIni.ReadString(sSection,'ConnectorType',rStdCredentials.ConnectorType);
//     result.customlibraryname:=MyIni.ReadString(sSection,'customlibraryname','');
//     result.caption:=MyIni.ReadString(sSection,'caption','no caption');
//     result.section:=sSection;
//   finally
//     freeandnil(MyIni);
//   end;
//   FsConnectorType:=result.ConnectorType;
//end;

function GetDefaultCredentials(FsConnectorType: string): TDBCredentials;
begin

  result.server:='';
  result.username:='';
  result.password:='';
  result.DatabaseName:='';
  result.CustomLibraryName:='';

  case FsConnectorType of

  'Firebird': begin
      result.server:='localhost';
      result.username:='SYSDBA';
      result.password:='masterkey';
      result.DatabaseName:='data.fdb';
  end;

  'Interbase': begin
      result.server:='localhost';
      result.username:='SYSDBA';
      result.password:='masterkey';
      result.DatabaseName:='data.fdb';
  end;

  'MSSQLServer':
    begin
    result.username:='sa';
    end;

  'MySQL 4.0','MySQL 4.1','MySQL 5.0','MySQL 5.1','MySQL 5.5','MySQL 5.6','MySQL 5.7','MySQL 8.0':
    begin
      result.server:='localhost';
      result.username:='username';
      result.password:='password';
      result.DatabaseName:='test';
    end;

  'ODBC':
    begin
    end;

  'Oracle':
    begin
    end;

  'PostgreSQL':
    begin
    end;

  'SQLite3':
    begin
    result.DatabaseName:=cSQLDatabaseFile;
    end;

  'Sybase':
    begin
    result.server:='localhost';
    result.username:='SYSDBA';
    result.password:='masterkey';
    result.DatabaseName:='data.fdb';
    end;


  else ;
    result.server:='localhost';
    result.username:='username';
    result.password:='password';
    result.DatabaseName:='databasename';
  end;

end; //GetDefaultCredentials

function GetDBconnectionsFromIni: string;
var
  MyIni:TIniFile;
  sIniFileName,sSection:string;
  slSections:TStringlist;
  i:integer;

  iCountDBSections:integer;
begin
  result:='';
  iCountDBSections:=0;

  sIniFileName:= GuessDBIniFile;
  MyIni := TIniFile.Create(sIniFileName);

  slSections:=TStringlist.Create;
  try
    MyIni.ReadSections(slSections);
    for i:=0 to slSections.Count -1 do
    begin
      sSection:=slSections.Strings[i];
      if sSection='Standard' then continue;

      if result ='' then
        result := sSection
      else
        result := result+';'+sSection;

      inc(iCountDBSections);
    end;

    if iCountDBSections<1 then
      raise Exception.Create('File: ' + {$INCLUDE %FILE%} + LineEnding +
                             'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding +
                             'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding + LineEnding+
                             'No valid Database connection section in configdb.ini');
  finally
    freeandnil(MyIni);
    freeandnil(slSections);
  end;

end;

{$R *.lfm}



{ Tdmsqldb }

procedure Tdmsqldb.DataModuleCreate(Sender: TObject);
begin
  FsPossibleConnectorTypes:=ListConnectionTypes(false);
  FsConnectorType:= cConnectorType;
  FDeleteDatabasefileBeforeOpen:=true;
  FImportDemoDataOnCreate:=true;

  FsIniFileName:=GuessDBIniFile;

  ReadStandardSectionFromIni; //Get Settings from INIfile
  FrCredentials:=ReadDefaultCredentialsFromIni;

  Initialize;
  if FImportDemoDataOnCreate then ImportData;
end;

procedure Tdmsqldb.SetConnectorType(AValue: string);
begin
  if FsConnectorType=AValue then Exit;
  FsConnectorType:=AValue;
end;


procedure Tdmsqldb.SetsIniFileName(AValue: String);
begin
  if FsIniFileName=AValue then Exit;
  FsIniFileName:=AValue;
end;

procedure Tdmsqldb.SetbDeleteDatabasefileBeforeOpen(AValue: boolean);
begin
  if FDeleteDatabasefileBeforeOpen=AValue then Exit;
  FDeleteDatabasefileBeforeOpen:=AValue;
end;

procedure Tdmsqldb.SetbAllowOpenDialogOnSQLImportFile(AValue: boolean);
begin
  if FbAllowOpenDialogOnSQLImportFile=AValue then Exit;
  FbAllowOpenDialogOnSQLImportFile:=AValue;
end;

procedure Tdmsqldb.SetbImportDemoDataOnCreate(AValue: boolean);
begin
  if FImportDemoDataOnCreate=AValue then Exit;
  FImportDemoDataOnCreate:=AValue;
end;

procedure Tdmsqldb.Initialize;
var
  sLibrary:string;
  sSQLfile:string;
begin
  CloseConnection;                                    //in case SQLDBLibraryLoader1 or SQLConnector1 were active in design mode close them

  //First
  sLibrary := MyGetLibraryName;
  if sLibrary = cUNDEF then exit;                     //for security reasons in case the exception fails

  //Second: load library
  MyLoadLib(FrCredentials.ConnectorType,sLibrary);

  //Third:
  // Try to find the Database file for file based systems or set credentials for others.
  // If database file for file bases systems do not exist create the named database file automatically

  //distinguish file databases versus server based databases
  case FrCredentials.ConnectorType of

  'Firebird','SQLite3': begin
    FrCredentials.DatabaseName := GuessSQLDatabaseFile(FDeleteDatabasefileBeforeOpen)
    //if FDeleteDatabasefileBeforeOpen then
    // FrCredentials.DatabaseName := GuessSQLDatabaseFile(true)
    //else
    // FrCredentials.DatabaseName := GuessSQLDatabaseFile(false);

    end;

  else
    //
  end;


  //case SQLServerType of
  //
  //  //ssInterbase,
  //  //ssFirebird,
  //  ssSQLite: begin
  //    if FDeleteDatabasefileBeforeOpen then
  //     FrCredentials.DatabaseName := GuessSQLDatabaseFile(true)
  //    else
  //     FrCredentials.DatabaseName := GuessSQLDatabaseFile(false);
  //
  //  end
  //  else begin
  //    //
  //  end;
  //end;

  SetCredentialsToSQLConnector;

  //SQLConnector1.ConnectorType:=FsConnectorType;
  SQLConnector1.CharSet:='UTF8';
  SQLConnector1.LoginPrompt := False;
  SQLConnector1.KeepConnection := False;
  SQLConnector1.Options:=[scoApplyUpdatesChecksRowsAffected] ;

  //+[sqImplicitTransaction];
  {
    TConnOption = (sqSupportParams, sqSupportEmptyDatabaseName, sqEscapeSlash, sqEscapeRepeat, sqImplicitTransaction, sqLastInsertID, sqSupportReturning,sqSequences);
  TConnOptions= set of TConnOption;


  Both sqoKeepOpenOnCommit and CommitRetaining will keep the result set open but they are not the same for transaction handling.

  Using sqoKeepOpenOnCommit with Commit will keep the result set and close the transaction.

  Using CommitRetaining will keep the result set and open a new transaction. I do not recommend using CommitRetaining unless you have a good reason for keeping an open transaction.

  }

  {$ifdef UseSQLLOG}
  SQLConnector1.OnLog:=@DoSQLLog;
  SQLConnector1.LogEvents:=LogAllEventsExtra;  //either LogAllEvents or LogAllEventsExtra
  {$endif}

end;

procedure Tdmsqldb.ImportData(sImportFile: string);
var
  TransactionWasStarted: boolean;

begin
  TransactionWasStarted:=SQLTransaction1.Active;
  if not TransactionWasStarted then SQLTransaction1.StartTransaction;

  if SQLQuery1.Active then SQLQuery1.Close;

  if sImportfile = '' then begin
     sImportFile := GuessSQLImportFile(FsSQLCustomImportFileName,FbAllowOpenDialogOnSQLImportFile);
     if sImportFile = cUNDEF then begin //just in case
        showmessage( 'SQL import file not found');
        exit;
     end
  end;
  if not FileExists(sImportFile) then begin
     showmessage('ImportData: File ' + sImportFile +'does not exist');
     exit;
  end;
  try
    SQLScript1.Script.LoadFromFile(sImportFile);
    SQLScript1.ExecuteScript;     //oder.Execute???
    SQLTransaction1.Commit;
  finally
    //
  end;
  // Make sure we leave the transaction state as we found it
  if TransactionWasStarted then SQLTransaction1.StartTransaction;
end;


procedure Tdmsqldb.OpenConnection;
begin
  if not SQLConnector1.Connected then
  begin
    try
      SQLConnector1.Open;
    except
      On E : Exception do
        begin
          showmessage( LineEnding
                      + 'File: ' + {$INCLUDE %FILE%} + LineEnding
                      + 'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding
                      + 'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding +LineEnding
                      + 'Connection to Database failed '  + LineEnding+ LineEnding
                      + E.Message);
          Exit;
        end;
    end;
    if not SQLConnector1.Connected then begin
      showmessage('Connection could not be established -- closing connection');
      SQLConnector1.Close;
    end;
  end;
end;

procedure Tdmsqldb.CloseConnection;
begin
    if SQLConnector1.Connected then SQLConnector1.Close;
end;

function Tdmsqldb.ListConnectionTypes(bCreateText: boolean): string;
Var
  S : TStringList;
  I : Integer;

begin
  S:=TStringList.Create;
  result:='';
  try
    getConnectionList(S);
    if s.Count=0 then showmessage('keine connections');

    if bCreateText then begin

      result:=LineEnding +'Available connection types:';
      For I:=0 to S.Count-1 do begin
        result:= result
                 + LineEnding
                 + S[i]
                 + ', Default library name: ' + GetConnectionDef(S[i]).DefaultLibraryName
                 + ', ConnectorType: ' + GetConnectionDef(S[i]).TypeName
                 ;
      end;
    end
    else
    begin
      For I:=0 to S.Count-1 do begin
        if i>0 then result:=result+';';
        result:=result+GetConnectionDef(S[i]).TypeName;
      end;
    end;

  finally
    S.free;
  end;
end;

function Tdmsqldb.GetStandardLibraryName(sConnector: string): string;
var
  S : TStringList;
  I : Integer;
begin
  result:=cUNDEF;
  S:=TStringList.Create;
  try
    getConnectionList(S);
    For I:=0 to S.Count-1 do
      if S[i] = sConnector then begin
        result := GetConnectionDef(S[i]).DefaultLibraryName;
        exit;
      end;
  finally
    S.free;
  end;

end;

procedure Tdmsqldb.MyLoadLib(sConnectionType, sLibname: String);
begin
  //Using Loadlibrary and unloadlibrary instead of enabling switch to catch exceptions
  try
    SQLDBLibraryLoader1.UnLoadLibrary;
  except
    On E : Exception do
      begin
        showmessage( LineEnding
                          + 'File: ' + {$INCLUDE %FILE%} + LineEnding
                          + 'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding
                          + 'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding +LineEnding
                          + 'Error unloading library : '+ SQLDBLibraryLoader1.LibraryName
                          + LineEnding + LineEnding
                          + E.Message);

        Exit;
      end;
  end;

  SQLDBLibraryLoader1.ConnectionType:=sConnectionType; //define connector Type
  SQLDBLibraryLoader1.LibraryName:=sLibname;
  try
    SQLDBLibraryLoader1.LoadLibrary;
  except
    On E : Exception do
      begin
        showmessage( LineEnding
                          + 'File: ' + {$INCLUDE %FILE%} + LineEnding
                          + 'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding
                          + 'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding +LineEnding
                          + 'Error loading library : '+ sLibName
                          + LineEnding + LineEnding
                          + E.Message);

        Exit;
      end;
  end;

end;

function Tdmsqldb.MyGetLibraryName: string;
var
  sStdLibName:string;
begin

  if FrCredentials.CustomLibraryName ='' then
    begin
      sStdLibName:='';
      sStdLibName:= GetStandardLibraryName(FsConnectorType);
    end;

  result:=cUNDEF;

  {$IFDEF UNIX}
    {$ifdef RasPi}
      result = '????';
    {$else}
      {$ifdef DARWIN}

        if FrCredentials.CustomLibraryName ='' then
          result='/usr/lib/'+sStdLibName
        else
          result='/usr/lib/'+FrCredentials.CustomLibraryName;

      {$else}

        if FrCredentials.CustomLibraryName ='' then
          result=sStdLibName
        else
          result=FrCredentials.CustomLibraryName;
      {$endif}
    {$endif}
  {$ELSE}       //windows OS

    if FrCredentials.CustomLibraryName ='' then begin
      result :='';
      result := GuessLibraryLocation(sStdLibName);
    end
    else
      result := GuessLibraryLocation(FrCredentials.CustomLibraryName);

  {$ENDIF}
end;

procedure Tdmsqldb.SetCredentialsToSQLConnector;
begin
  SQLConnector1.ConnectorType:=FrCredentials.ConnectorType;
  SQLConnector1.DatabaseName:=FrCredentials.DatabaseName;
  SQLConnector1.UserName:=FrCredentials.username;
  SQLConnector1.Password:=FrCredentials.password;
  SQLConnector1.Hostname:=FrCredentials.server;
end;

function Tdmsqldb.GetSQLiteVersion: string;
var
  SQLQ:TSQLQuery;
begin
  result:='No SQLite3 Connection';

  if SQLConnector1.ConnectorType=cSQLiteType then begin
    SQLQ:=TSQLQuery.Create(nil);
    try
      SQLQ.DataBase := SQLConnector1;
      SQLQ.SQL.Text:='SELECT sqlite_version() AS version';
      SQLQ.Open;
      SQLQ.First;
      result:=SQLQ.FieldByName('version').AsString;
      SQLQ.Close;
    finally
      freeandnil(SQLQ);
    end;
  end;

end;
{In case you need an additional TSQLQuery use it like
procedure CreateTable;
var Query : TSQLQuery;
begin
  try
    Query := GetQuery;
    Query.SQL.Text := 'create table TBLNAMES (ID integer, NAME varchar(40));';
    Query.ExecSQL;
    Query.Close;
  finally
    Query.Free;
  end;
end;}
function Tdmsqldb.GetQuery: TSQLQuery;
var
  AQuery : TSQLQuery;
begin
  AQuery := TSQLQuery.Create(nil);
  AQuery.Database := SQLConnector1;
  AQuery.Transaction := SQLTransaction1;
  Result := AQuery;
end;

procedure Tdmsqldb.ReadStandardSectionFromIni;
var
   MyIni:TIniFile;
   b:boolean;
begin
   MyIni := TIniFile.Create(FsIniFileName);
   try

     b:=MyIni.ReadBool('Standard','ImportDemoDataOnCreate',true);
     FImportDemoDataOnCreate:=      MyIni.ReadBool('Standard','ImportDemoDataOnCreate',true);

     b:=MyIni.ReadBool('Standard','DeleteDatabasefileBeforeOpen',true);
     FDeleteDatabasefileBeforeOpen:=MyIni.ReadBool('Standard','DeleteDatabasefileBeforeOpen',true);

     FbAllowOpenDialogOnSQLImportFile:=MyIni.ReadBool('Standard','AllowOpenDialogOnSQLImportFile',false);

     //sDefaultSectionName:=MyIni.ReadString('Standard','startdbfromsection','SQLITE_demodb');
     //sDefaultSectionName:=MyIni.ReadBool('Standard','choosedatabase','SQLITE_demodb');
     //sDefaultSectionName:=MyIni.ReadString('Standard','SQLCustomImportFileName','SQLITE_demodb');

   finally
     freeandnil(MyIni);
   end;

end;

function Tdmsqldb.ReadDefaultCredentialsFromIni: TDBCredentials;
var
   MyIni:TIniFile;
   sDefaultSectionName:string;
begin
   MyIni := TIniFile.Create(FsIniFileName);
   try
     sDefaultSectionName:=MyIni.ReadString('Standard','startdbfromsection','SQLITE_demodb');
   finally
     freeandnil(MyIni);
   end;
   result:= GetCredentialsFromIniSection(sDefaultSectionName,FsIniFileName);
end;

procedure Tdmsqldb.RefreshCredentials(sSection: string);
begin
  FrCredentials:=GetCredentialsFromIniSection(sSection,FsIniFileName);
end;

function Tdmsqldb.GetCredentialsFromIniSection(sSection: string;
  sIniFileName: string): TDBCredentials;
var
   MyIni:TIniFile;
   rStdCredentials:TDBCredentials;
   sMyIniFileName:string;
   sMyConnectorType:string;
begin

   if sIniFileName = '' then
     sMyIniFileName:=GuessDBIniFile
   else
     sMyIniFileName:=sIniFileName;

   MyIni := TIniFile.Create(sMyIniFileName);
   try
     sMyConnectorType:=MyIni.ReadString(sSection,'ConnectorType',cConnectorType);
     rStdCredentials:=GetDefaultCredentials(sMyConnectorType);

     result.Server:=MyIni.ReadString(sSection,'Server',rStdCredentials.server);
     result.username:=MyIni.ReadString(sSection,'Username',rStdCredentials.username);
     result.password:=MyIni.ReadString(sSection,'Password',rStdCredentials.password);
     result.DatabaseName:=MyIni.ReadString(sSection,'DatabaseName',rStdCredentials.DatabaseName);
     result.ConnectorType:=MyIni.ReadString(sSection,'ConnectorType',rStdCredentials.ConnectorType);
     result.customlibraryname:=MyIni.ReadString(sSection,'customlibraryname','');
     result.caption:=MyIni.ReadString(sSection,'caption','no caption');
     result.section:=sSection;
   finally
     freeandnil(MyIni);
   end;
   FsConnectorType:=result.ConnectorType;

end;


end.

