unit udmsqldbsimple;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, SQLite3Conn, SQLDB, uguessfile, dialogs, SQLScript;

type

  { TdmSQLDBSimple }

  TdmSQLDBSimple = class(TDataModule)
    SQLite3Connection1: TSQLite3Connection;
    SQLQuery1: TSQLQuery;
    SQLScript1: TSQLScript;
    SQLTransaction1: TSQLTransaction;
    procedure DataModuleCreate(Sender: TObject);
  private

  public
    procedure ImportData(sImportFile: string='');
    function GetSQLiteVersion:string;
  end;

var
  dmSQLDBSimple: TdmSQLDBSimple;

implementation

{$R *.lfm}

{ TdmSQLDBSimple }

procedure TdmSQLDBSimple.DataModuleCreate(Sender: TObject);
begin
  if not SQLite3Connection1.Connected then SQLite3Connection1.Open;
end;

procedure TdmSQLDBSimple.ImportData(sImportFile: string);
begin
  if sImportfile = '' then begin
     sImportFile := GuessSQLImportFile;
     if sImportFile = cUNDEF then begin //just in case
        showmessage( 'SQL import file not found');
        exit;
     end
  end;
  if not FileExists(sImportFile) then begin
     showmessage('ImportData: File ' + sImportFile +'does not exist');
     exit;
  end;
  try
    SQLScript1.Script.LoadFromFile(sImportFile);
    SQLScript1.Execute;
  finally
    //
  end;
end;

function TdmSQLDBSimple.GetSQLiteVersion: string;
begin
  result:='';
  if SQLQuery1.Active then SQLQuery1.Close;
  SQLQuery1.SQL.Text:='SELECT sqlite_version() AS version';
  SQLQuery1.Open;
  SQLQuery1.First;
  result:=SQLQuery1.FieldByName('version').AsString;
  SQLQuery1.Close;
end;

end.

