unit fcredentials;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, BufDataset, DB, memds, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, DBCtrls, ActnList, ComCtrls;

//const
//  {$include demosettings.Inc}

type

  { TfrmCredentials }

  TfrmCredentials = class(TForm)
    actn_MakeConnectionDefault: TAction;
    actn_TestConnection: TAction;
    actn_ReadAllFromIni: TAction;
    ActionList1: TActionList;
    Button1: TButton;
    bttnSave: TButton;
    bttnMakeDefault: TButton;
    bttnNew: TButton;
    bttbGetStandardCredentials: TButton;
    bttnEdit: TButton;
    bttnTest: TButton;
    CheckBox1: TCheckBox;
    cbDeleteDatabasefileBeforeOpen: TCheckBox;
    DataSource1: TDataSource;
    cbConnectionTypes: TDBComboBox;
    DBNavigator1: TDBNavigator;
    eSection: TDBEdit;
    eServer: TDBEdit;
    eDatabasename: TDBEdit;
    eUsername: TDBEdit;
    ePassword: TDBEdit;
    eCustomLibraryName: TDBEdit;
    eCaption: TDBEdit;
    DBGrid1: TDBGrid;
    mDescription: TDBMemo;
    eSQLCustomImportFileName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TConnections: TMemDataset;

    procedure actn_MakeConnectionDefaultExecute(Sender: TObject);
    procedure actn_ReadAllFromIniExecute(Sender: TObject);
    procedure actn_TestConnectionExecute(Sender: TObject);
    procedure bttbGetStandardCredentialsClick(Sender: TObject);
    procedure bttnMakeDefaultClick(Sender: TObject);
    procedure bttnSaveClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DBNavigator1Click(Sender: TObject; Button: TDBNavButtonType);
    procedure FormCreate(Sender: TObject);
    procedure TConnectionsBeforeDelete(DataSet: TDataSet);
  private
    FsCurrentSection:string;
    function ReadIniToTConnections: boolean;
    procedure CreateSettingsTable;
  public
    //function GetCredentialsFromIni(FsConnectorType:string):TDBCredentials;
    procedure WriteCredentialsToIni(sSection:string);
    procedure DeleteCredentialFromIni(sSection:string);
    //function GetStandardCredentials(FsConnectorType:string):TDBCredentials;
    procedure disenable(MyEnabled:boolean=true);
    procedure preparegrid;
  end;

var
  frmCredentials: TfrmCredentials;
 // procedure WriteCredentialsToIni(sSection:string);

  //function ReadDefaultCredentialsFromIni:TDBCredentials;
  //function GetCredentialsFromIniSection(sSection:string; sIniFileName:string=''):TDBCredentials;
  //function GetDefaultCredentials(FsConnectorType:string):TDBCredentials;
implementation

{$R *.lfm}

uses
  uguessfile, inifiles, udmsqldb;

{ TfrmCredentials }

procedure TfrmCredentials.Button1Click(Sender: TObject);
begin

end;

procedure TfrmCredentials.DBNavigator1Click(Sender: TObject;
  Button: TDBNavButtonType);
begin
  case Button of
  nbFirst :    begin
    end;
  nbPrior :    begin
    end;
  nbLast :    begin
    end;
  nbInsert :    begin
     disenable(true);
    end;
  nbEdit :    begin
    disenable(true);
    end;
  nbPost :    begin
    disenable(false);
  end;
  nbCancel :    begin
    disenable(false);
    end;
  nbDelete :    begin
    disenable(false);
    //showmessage(esection.text);
    //DeleteCredentialFromIni(eSection.text);
    //ReadIniToTConnections;
    end;
  nbRefresh:    begin
    ReadIniToTConnections;
    end;
  end; //case
end;

procedure TfrmCredentials.actn_ReadAllFromIniExecute(Sender: TObject);
begin
  ReadIniToTConnections;
end;

procedure TfrmCredentials.actn_MakeConnectionDefaultExecute(Sender: TObject);
var
   MyIni:TIniFile;
   sIniFileName:string;
begin
   sIniFileName:=GuessDBIniFile;
   MyIni := TIniFile.Create(sIniFileName);
   try
   MyIni.WriteString('Standard','startdbfromsection',TConnections.FieldByName('section').AsString);
   finally
     freeandnil(MyIni);
   end;
end;

procedure TfrmCredentials.actn_TestConnectionExecute(Sender: TObject);
begin
  //write current data to ini
  //dmsqldb.prCredentials:=GetCredentialsFromIniSection(eSection.Text,dmsqldb.psIniFileName);
  dmsqldb.RefreshCredentials(eSection.Text);
  dmsqldb.Initialize;
  dmsqldb.OpenConnection;
  If dmsqldb.SQLConnector1.Connected then
    showmessage('Connection established, Database ready')
  else
    showmessage('Could not establish connection, Database offline');
end;

procedure TfrmCredentials.bttbGetStandardCredentialsClick(Sender: TObject);
var
   stdcred:TDBCredentials;
begin
  stdcred:=GetDefaultCredentials(cbConnectionTypes.Text);
  //eSection.Text:=stdcred;
  eServer.Text:=stdcred.Server;
  eDatabasename.Text:=stdcred.DatabaseName;
  eUsername.Text:=stdcred.Username;
  ePassword.Text:=stdcred.Password;
  eCustomLibraryName.Text:=stdcred.CustomLibraryName;
  eCaption.Text:=stdcred.caption;
  //mDescription.Text:=stdcred.;
end;

procedure TfrmCredentials.bttnMakeDefaultClick(Sender: TObject);
begin

end;

procedure TfrmCredentials.bttnSaveClick(Sender: TObject);
begin
  WriteCredentialsToIni(eSection.text);
end;

procedure TfrmCredentials.FormCreate(Sender: TObject);
begin
  CreateSettingsTable;
  preparegrid;

  cbConnectionTypes.Items.AddDelimitedtext(dmsqldb.ListConnectionTypes(false),';',true);

  ReadIniToTConnections;
  TConnections.First;
end;

procedure TfrmCredentials.TConnectionsBeforeDelete(DataSet: TDataSet);
begin
    showmessage(esection.text);
    DeleteCredentialFromIni(eSection.text);
    ReadIniToTConnections;
end;


function TfrmCredentials.ReadIniToTConnections: boolean;
var
  MyIni:TIniFile;
  sIniFileName:string;

  slSections:TStringlist;
  i,j:integer;
  s,sSection,sConnectortype,sCustomLibraryname:string;
  iCountDoConnects:integer;
  bCheckFlag:boolean;

  stdCredentials:TDBCredentials;
begin
  bCheckFlag:=false;

  sIniFileName:= GuessDBIniFile;

  iCountDoConnects:=0;

  MyIni := TIniFile.Create(sIniFileName);

  slSections:=TStringlist.Create;

  TConnections.Clear(false);  //die Definitionen nicht mitlöschen, nur Inhalte löschen
  TConnections.DisableControls;

  try
    MyIni.ReadSections(slSections);
    for i:=0 to slSections.Count -1 do
    begin
      sSection:=slSections.Strings[i];

      //In der Section [Standard] stehen allgemeine Einstellungen
      //die werden beiem Ausleden der DB-Einstellungen ausgelassen.
      if sSection='Standard' then continue;

      sConnectortype:=MyIni.ReadString(sSection,'connectortype','');
      if sConnectortype='' then showmessage('ohne connectortype gehts nicht');
      stdCredentials:=GetDefaultCredentials(sConnectortype);

      If not TConnections.Active then TConnections.Open;
      TConnections.Append;
      TConnections.FieldByName('section').AsString:=sSection;
      TConnections.FieldByName('server').AsString:=MyIni.ReadString(sSection,'server',stdCredentials.server);
      TConnections.FieldByName('databasename').AsString:=MyIni.ReadString(sSection,'databasename',stdCredentials.DatabaseName);
      TConnections.FieldByName('username').AsString:=MyIni.ReadString(sSection,'username',stdCredentials.Username);
      TConnections.FieldByName('password').AsString:=MyIni.ReadString(sSection,'password',stdCredentials.Password);
      TConnections.FieldByName('connectortype').AsString:=sConnectortype;

      s:=MyIni.ReadString(sSection,'caption','');
      if s='' then s:= sSection;
      TConnections.FieldByName('caption').AsString:=s;
      TConnections.FieldByName('description').AsString:=MyIni.ReadString(sSection,'description','');

      s:= MyIni.ReadString(sSection,'order','');
      //if s='' then j:=0;
      if s='' then j:=i+1;
      TConnections.FieldByName('order').AsInteger:= j;


      //s:=MyIni.ReadString(sSection,'port','');
      //if s<>'' then
      //  TConnections.FieldByName('port').AsInteger:= StrToInt(s)
      //else
      //  begin
      //    j:= GuessStandardPort(sConnectortype);
      //    TConnections.FieldByName('port').AsInteger:= j;
      //  end;

      sCustomLibraryname:= MyIni.ReadString(sSection,'CustomLibraryName','');
      if sCustomLibraryname='' then
          //sCustomLibraryname:=GuessLibraryLocation(sConnectortype)
      else
         begin
           //evtl eingetragene dll auf Plausibilität checken
         end;
      TConnections.FieldByName('CustomLibraryName').AsString:=sCustomLibraryname;

      //Nur checken falls doconnect=1
      //if StrToInt(s)=1 then  bCheckFlag:=true else bCheckFlag:=false;

      //begin
      //   { TODO : nur für doconnect=1 alles einzeln prüfen, sonst ungeprüft eintragen }
      //end;


      TConnections.Post;

    end;  //for

    TConnections.First;

    //if iCountDoConnects=0 then
    //  raise Exception.Create('File: ' + {$INCLUDE %FILE%} + LineEnding +
    //                         'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding +
    //                         'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding + LineEnding+
    //                         'Es wurde kein DoConnect=1 in der configdb.ini gesetzt');
    //
    //if iCountDoConnects>1 then
    //  raise Exception.Create('File: ' + {$INCLUDE %FILE%} + LineEnding +
    //                         'Methodname: ' +  {$I %CURRENTROUTINE%} + LineEnding +
    //                         'Linenumber: ' + {$INCLUDE %LINE%} + LineEnding + LineEnding+
    //                         'Es wurde mehr als ein DoConnect=1 in der configdb.ini gesetzt');
  finally
    freeandnil(MyIni);
    freeandnil(slSections);

    TConnections.EnableControls;
  end;

end;

procedure TfrmCredentials.CreateSettingsTable;
var
  afield:TFieldDef;
begin
  //TConnections.Close;
  //
  ////Now, creating the field defs.
  //with TConnections.FieldDefs do
  //begin
  //  Clear;                                 //We dont need this line, but it does not hurt either.
  //  Add('primid', ftAutoInc, 5, False);
  //  //Add('primid', ftInteger, 5, False);
  //  Add('section', ftString, 100, False);
  //
  //  Add('server', ftString, 100, False);
  //  //Add('port', ftInteger, 0, False);
  //  Add('databasename', ftString, 100, False);
  //  Add('username', ftString, 100, False);
  //  Add('password', ftString, 100, False);
  //  Add('connectortype', ftString, 100, False);
  //  Add('customlibraryname', ftString, 100, False);
  //  Add('order', ftInteger, 0, False);
  //  Add('caption', FtString, 100, False);
  //  Add('description', ftMemo, 0, False);
  //
  //end;
  //TConnections.CreateTable;
  ////TConnections.CreateDataset;//???
  ////TConnections.CreateTable;
  ////SetColumnWidth;
  TConnections.Open;
end;

procedure TfrmCredentials.WriteCredentialsToIni(sSection: string);
var
   MyIni:TIniFile;
begin
  if (TConnections.State in [dsEdit, dsInsert]) then TConnections.Post;

  MyIni := TIniFile.Create(dmsqldb.psIniFileName);
  try
    MyIni.ReadString(sSection,'Server',TConnections.FieldByName('server').AsString);
    MyIni.ReadString(sSection,'Username',TConnections.FieldByName('username').AsString);
    MyIni.ReadString(sSection,'Password',TConnections.FieldByName('password').AsString);
    MyIni.ReadString(sSection,'DatabaseName',TConnections.FieldByName('databasename').AsString);
    MyIni.ReadString(sSection,'ConnectorType',TConnections.FieldByName('connectortype').AsString);
    MyIni.ReadString(sSection,'CustomLibraryName',TConnections.FieldByName('customlibraryname').AsString);
    MyIni.ReadString(sSection,'Caption',TConnections.FieldByName('caption').AsString);
    MyIni.ReadString(sSection,'Description',TConnections.FieldByName('description').AsString);
  finally
    freeandnil(MyIni);
  end;
end;

procedure TfrmCredentials.DeleteCredentialFromIni(sSection: string);
var
   MyIni:TIniFile;
begin
  if (TConnections.State in [dsEdit, dsInsert]) then TConnections.Post;

  MyIni := TIniFile.Create(dmsqldb.psIniFileName);
  try
    MyIni.EraseSection(sSection);
  finally
    freeandnil(MyIni);
  end;
end;

procedure TfrmCredentials.disenable(MyEnabled: boolean);
begin
  cbConnectionTypes.Enabled:=Myenabled;
  eSection.Enabled:=Myenabled;
  eServer.Enabled:=Myenabled;
  eDatabasename.Enabled:=Myenabled;
  eUsername.Enabled:=Myenabled;
  ePassword.Enabled:=Myenabled;
  eCustomLibraryName.Enabled:=Myenabled;
  eCaption.Enabled:=Myenabled;
  mDescription.Enabled:=Myenabled;
end;

procedure TfrmCredentials.preparegrid;
begin
  //DBGrid1.Columns.Clear;
  //
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'section';
  //  Title.Caption := 'section';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'server';
  //  Title.Caption := 'server';
  //  width:=30;
  //end;
  //  with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'databasename';
  //  Title.Caption := 'databasename';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'username';
  //  Title.Caption := 'username';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'password';
  //  Title.Caption := 'password';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'connectortype';
  //  Title.Caption := 'connectortype';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'customlibraryname';
  //  Title.Caption := 'customlibraryname';
  //  width:=30;
  //
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'caption';
  //  Title.Caption := 'caption';
  //  width:=30;
  //end;
  //with TColumn(DBGrid1.Columns.Add) do
  //begin
  //  fieldname := 'description';
  //  Title.Caption := 'description';
  //  width:=30;
  //end;

end;

//function ReadDefaultCredentialsFromIni: TDBCredentials;
//var
//   MyIni:TIniFile;
//   sIniFileName:string;
//   sDefaultSectionName:string;
//begin
//   sIniFileName:=GuessDBIniFile;
//   if sIniFileName = cUNDEF then
//      sIniFileName:=CreateStandardIniFile;
//
//   MyIni := TIniFile.Create(sIniFileName);
//   try
//     sDefaultSectionName:=MyIni.ReadString('Standard','startdbfromsection','SQLITE_demodb');
//   finally
//     freeandnil(MyIni);
//   end;
//   result:= GetCredentialsFromIniSection(sDefaultSectionName,sIniFileName);
//end;

//function GetCredentialsFromIniSection(sSection: string; sIniFileName: string
//  ): TDBCredentials;
//var
//   MyIni:TIniFile;
//   rStdCredentials:TDBCredentials;
//   sMyIniFileName:string;
//   sMyConnectorType:string;
//begin
//
//   if sIniFileName = '' then begin
//     sMyIniFileName:=GuessDBIniFile;
//     if sMyIniFileName = cUNDEF then
//        sMyIniFileName:=CreateStandardIniFile;
//   end else
//   sMyIniFileName:=sIniFileName;
//
//   MyIni := TIniFile.Create(sMyIniFileName);
//   try
//     sMyConnectorType:=MyIni.ReadString(sSection,'ConnectorType',cConnectorType);
//     rStdCredentials:=GetDefaultCredentials(sMyConnectorType);
//
//     result.Server:=MyIni.ReadString(sSection,'Server',rStdCredentials.server);
//     result.username:=MyIni.ReadString(sSection,'Username',rStdCredentials.username);
//     result.password:=MyIni.ReadString(sSection,'Password',rStdCredentials.password);
//     result.DatabaseName:=MyIni.ReadString(sSection,'DatabaseName',rStdCredentials.DatabaseName);
//     result.ConnectorType:=MyIni.ReadString(sSection,'ConnectorType',rStdCredentials.ConnectorType);
//     result.customlibraryname:=MyIni.ReadString(sSection,'customlibraryname',rStdCredentials.customlibraryname);
//   finally
//     freeandnil(MyIni);
//   end;
//
//end;


//procedure WriteCredentialsToIni(sSection: string);
//var
//   MyIni:TIniFile;
//begin
//  TConnections.Post;
//  MyIni := TIniFile.Create(dmsqldb.psIniFileName);
//  try
//    MyIni.ReadString(sSection,'Server',TConnections.FieldByName('server').AsString);
//    MyIni.ReadString(sSection,'Username',TConnections.FieldByName('username').AsString);
//    MyIni.ReadString(sSection,'Password',TConnections.FieldByName('password').AsString);
//    MyIni.ReadString(sSection,'DatabaseName',TConnections.FieldByName('databasename').AsString);
//    MyIni.ReadString(sSection,'ConnectorType',TConnections.FieldByName('connectortype').AsString);
//    MyIni.ReadString(sSection,'CustomLibraryName',TConnections.FieldByName('customlibraryname').AsString);
//    MyIni.ReadString(sSection,'Caption',TConnections.FieldByName('caption').AsString);
//    MyIni.ReadString(sSection,'Description',TConnections.FieldByName('description').AsString);
//  finally
//    freeandnil(MyIni);
//  end;
//
//end;

//function GetDefaultCredentials(FsConnectorType: string
//  ): TDBCredentials;
//begin
//  result.server:='';
//  result.username:='';
//  result.password:='';
//  result.DatabaseName:='';
//  result.CustomLibraryName:='';
//
//  case FsConnectorType of
//
//  'Firebird': begin
//      result.server:='localhost';
//      result.username:='SYSDBA';
//      result.password:='masterkey';
//      result.DatabaseName:='data.fdb';
//  end;
//
//  'Interbase': begin
//      result.server:='localhost';
//      result.username:='SYSDBA';
//      result.password:='masterkey';
//      result.DatabaseName:='data.fdb';
//  end;
//
//  'MSSQLServer':
//    begin
//   // result.server:='localhost';
//    result.username:='sa';
//   // result.password:=;
//    result.CustomLibraryName:='dblib.dll';
//    end;
//
//  'MySQL 4.0','MySQL 4.1','MySQL 5.0','MySQL 5.1','MySQL 5.5','MySQL 5.6','MySQL 5.7','MySQL 8.0':
//    begin
//    result.CustomLibraryName:='libmysql.dll';
//    end;
//
//  'ODBC':
//    begin
//    end;
//
//  'Oracle':
//    begin
//    result.CustomLibraryName:='oci.dll';
//    end;
//
//  'PostgreSQL':
//    begin
//    result.CustomLibraryName:='libpq.dll';
//    end;
//
//  'SQLite3':
//    begin
//    result.DatabaseName:='demo.db';
//    result.CustomLibraryName:='';
//    //result.CustomLibraryName:='sqlite3.dll';
//    end;
//
//  'Sybase':
//    begin
//    result.server:='localhost';
//    result.username:='SYSDBA';
//    result.password:='masterkey';
//    result.DatabaseName:='data.fdb';
//    result.CustomLibraryName:='dblib.dll';
//    end;
//
//
//  else ;
//    result.server:='localhost';
//    result.username:='username';
//    result.password:='password';
//    result.DatabaseName:='databasename';
//  end;
//end;

end.

